declare filename "HybridM.dsp"; declare name "HybridM"; import("stdfaust.lib");

// Play / Pause program

gatePg = checkbox ("h:[0]General/[0]Start Program[tooltip: Check to start the Program]");

// External Entry

switch = checkbox("h:[1]External Entry/[0]External Signal On [tooltip: Check to allow external signal to be processed]");
gainIn = hslider("h:[1]External Entry/[1]External Signal Gain[tooltip: Adjust external signal volume]",0,0,1,0.01);

// Sound

gateS = checkbox("h:[2]Sound Control/v:[0]Fundamental/[0]Play Fundamental [tooltip: Check to start processing the oscillator]");
freqP = hslider("h:[2]Sound Control/v:[0]Fundamental/[1]Frequency[tooltip: Adjust the ocillator frequency]",440,50,3000,0.01): si.smoo;
g = hslider("h:[0]General/[1]Gain[style:knob][tooltip: Adjust the program volume]",0.5,0,1,0.01) :si.smoo;
go= hslider("h:[2]Sound Control/v:[0]Fundamental/[2]Gain [tooltip: Adjust the oscillator gain]",0.5,0,1,0.01) :si.smoo;

    //Vibrato

gateV = checkbox("h:[2]Sound Control/v:[0]Fundamental/[3]Play Vibrato[tooltip: Check to start the Vibrato]");
a = hslider("h:[2]Sound Control/v:[0]Fundamental/[5]Vibrato Amplitude[style:knob[tooltip: Adjust the amont of vibrato (from 2 to 10 Hz)]]",6,2,10,1) :si.smoo;
fo = hslider("h:[2]Sound Control/v:[0]Fundamental/[4]Vibrato Frequency[tooltip: adjust the vibrato frequency : tight or large]",5,0.5,10,0.01) :si.smoo; 
f = freqP+a*os.osc(fo)*gateV; 

    //Panner

p = hslider("h:[0]General/[2]Panner[style:knob][tooltip: Switch to adjust pannoramisation]",0.5,0,1,0.01) : si.smoo ;
panner(p) = _ <: *(1-p),*(p);

// Additive Synthesis

    // Harmony ( Notes)

fscm = 25/24*f; // Minor Second
gatefscm = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[0]Minor Second[tooltip: Check to start the note]");

fsc = 10/9*f; // Major Second
gatefsc = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[1]Major Second[tooltip: Check to start the note]");

ftm = 6/5*f; // Minor Third
gateftm = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[2]Minor Third[tooltip: Check to start the note]");

ft = 5/4*f; // Major Third 
gatfet = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[3]Major Third[tooltip: Check to start the note]");

ffth = 4/3*f; // Fourth
gatefth = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[4]Fourth[tooltip: Check to start the note]");

fdf = 25/18*f;  // Diminished Fifth
gatedf = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[5]Diminished Fifth[tooltip: Check to start the note]");

fq = 3/2*f; // Fifth 
gatefq = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[6]Fifth[tooltip: Check to start the note]");

fstm = 8/5*f; // Minor Sixth
gatefstm = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[7]Minor Sixth[tooltip: Check to start the note ]");

fst = 5/3*f; // Major Sixth
gatefst = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[8]Major Sixth[tooltip: Check to start the note]");

fsm = 9/5*f; // Minor Seventh
gatefsm = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[9]Minor Seventh[tooltip: Check to start the note]");

fs = 15/8*f; // Major Seventh
gatefsv = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[a]Major Seventh[tooltip: Check to start the note]");

foc = 2*f; // Octave 
gatefoc = checkbox ("h:[2]Sound Control/t:[1]Secondary Sounds/v:[1]Harmony/[b]Octave[tooltip: Check to start the note]");


    // Harmonics

g2 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 1[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g3 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 2[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g4 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 3[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g5 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 4[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g6 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 5[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g7 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 6[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g8 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 7[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g9 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 8[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g10 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 9[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;
g11 = hslider("h:[2]Sound Control/t:[1]Secondary Sounds/v:[0]Harmonics/Gain Harmonic 10[tooltip: Adjust the volume of the harmonic]",0,0,1,0.01) :si.smoo;


// Comb Filter

comb(del,ff) = _ <: _,de.delay(100,del)*ff :> _;
d = hslider("h:[3]Effects and filters/v:[4]Comb Filter/[0]Delay[style:knob][tooltip: Adjust the delay time]",1,1,99,1) : si.smoo;
ffor = hslider("h:[3]Effects and filters/v:[4]Comb Filter/[1]FeedForward[style:knob][tooltip: Adjust the absorption parameter]",1,0,1,0.01) : si.smoo;

// Doppler Effect
doppler(distance,freq) = de.fdelay4(100000,dist*osc+1)
with{
  dist= distance*ma.SR/340;
  osc = os.osc(freq)*0.5+0.5;
};
dist = hslider("h:[3]Effects and filters/v:[5]Doppler/[0]Distance[style:knob][tooltip:Adjust the distance between the transmitter and the receiver]",0,0,600,0.01) : si.smoo; // in meters 
fr = hslider("h:[3]Effects and filters/v:[5]Doppler/[1]FrequencyDoppler[style:knob][tooltip: Adjust the speed of the transmitter]",0.01,0.01,2,0.01) : si.smoo;

// Echo
echo(duration,feedback) = +~de.delay(50000,del)*(feedback)
with{
  del = duration*ma.SR;
};
dur = hslider("h:[3]Effects and filters/v:[3]Echo/[0]Duration[style:knob][tooltip: Adjust the delay time]",0,0,1,0.01) : si.smoo;
feed = hslider("h:[3]Effects and filters/v:[3]Echo/[1]Feedback[style:knob][tooltip: Adjust the absorption parameter]",0,0,1,0.01) : si.smoo;

// Distortion
     // Created with cubicnl_demo
ldisto = ba.bypass1(bp, ef.cubicnl_nodc(drive:si.smoo,offset:si.smoo))
with{
    bp = 1-vslider("h:[3]Effects and filters/v:[2]Distortion/[0]Pass[style:menu{'Bypass':0;'Pass':1}]",0,0,1,1);
	drive = vslider("h:[3]Effects and filters/v:[2]Distortion/[1] Drive [style:knob][tooltip: Amount of distortion]",0, 0, 1, 0.01) :si.smoo;
	offset = vslider("h:[3]Effects and filters/v:[2]Distortion/[2] Offset [style:knob][tooltip: Brings in even harmonics]",
		0, 0, 1, 0.01) :si.smoo;
};

// Wah
    // Created with wah4_demo

lwah = ba.bypass1(bpw, ve.wah4(fr))
with{
	bpw = 1-vslider("h:[3]Effects and filters/v:[1]Wah/[0]Pass[style:menu{'Bypass':0;'Pass':1}][tooltip: Check to start the Distortion]",0,0,1,1);
	fr = vslider("h:[3]Effects and filters/v:[1]Wah/[1] Resonance Frequency [scale:log] [tooltip: wah resonance frequency in Hz]", 1500,100,2000,1) :si.smoo;
};

// Reverb
    // Created with freeverb_demo code

lreverb = _,_ <: (*(g)*fixedgain,*(g)*fixedgain :
	re.stereo_freeverb(combfeed, allpassfeed, damping, spatSpread)),
	*(1-g), *(1-g) :> _,_
with{
	scaleroom   = 0.28;
	offsetroom  = 0.7;
	allpassfeed = 0.5;
	scaledamp   = 0.4;
	fixedgain   = 0.1;
	origSR = 44100;

	
	damping = vslider("h:[3]Effects and filters/h:[0]Reverb/v: [0]Controls/[0] Resonance Frequency [style: knob] [tooltip: Somehow control the density of the reverb]",0.5, 0, 1, 0.025)*scaledamp*origSR/ma.SR;
	combfeed = vslider("h:[3]Effects and filters/h:[0]Reverb/v: [0]Controls/[1] RoomSize [style: knob] [tooltip: The room size between 0 and 1 with 1 for the largest room]", 0.5, 0, 1, 0.025)*scaleroom*
		origSR/ma.SR + offsetroom;
	spatSpread = vslider("h:[3]Effects and filters/h:[0]Reverb/v: [0]Controls/[2] Stereo Spread [style: knob] [tooltip: Spatial spread between 0 and 1 with 1 for maximum spread]",0.5,0,1,0.01)*46*ma.SR/origSR
		: int;
	g = vslider("h:[3]Effects and filters/h:[0]Reverb/[1] Wet [tooltip: The amount of reverb applied to the signal
		between 0 and 1 with 1 for the maximum amount of reverb]", 0, 0, 1, 0.025);
        };

// Process

process=

(_,_:>_*switch*gainIn*0.5) , (


os.osc (f) * 0.2 * gateS ,

(os.osc (fscm) * gatefscm +
os.osc (fsc) * gatefsc +
os.osc (ftm) * gateftm +
os.osc (ft) * gatfet +
os.osc (ffth) * gatefth +
os.osc (fdf) * gatedf +
os.osc (fq) * gatefq +
os.osc (fstm) * gatefstm +
os.osc (fst) * gatefst +
os.osc (fsm) * gatefsm +
os.osc (fs) * gatefsv +
os.osc (foc) * gatefoc ) +

(os.osc (2*f) * g2 +
os.osc (3*f) * g3 +
os.osc (4*f) * g4 +
os.osc (5*f) * g5 +
os.osc (6*f) * g6 +
os.osc (7*f) * g7 +
os.osc (8*f) * g8 +
os.osc (9*f) * g9 +
os.osc (10*f) * g10 )

:>_*go:co.compressor_mono(10,-15,0.01,0.03) ):>_

* g

:doppler(dist,fr)
:ldisto
:lwah
:comb(d,ffor)

:echo(dur,feed)
:panner (p)<:_*gatePg,_*gatePg
:lreverb
;